from temporalio.converter import DataConverter, PayloadCodec, EncodingPayloadConverter, CompositePayloadConverter
import dataclasses

class BaseDataConverter:
    converter = DataConverter.default

    def replace_payload_codec(self, payload_codec: PayloadCodec) -> 'BaseDataConverter':
        self.converter = dataclasses.replace(self.converter, payload_codec=payload_codec)
        return self
    
    def replace_payload_converter(self, payload_converter: EncodingPayloadConverter) -> 'BaseDataConverter':
        self.converter = dataclasses.replace(self.converter, payload_converter=payload_converter)
        return self
        
    def get_converter(self) -> DataConverter:
        return self.converter